var _class, _class2, _temp2, _class3, _desc, _value, _class4, _descriptor;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import { FormControl, Pagination as _Pagination } from 'react-bootstrap';
import classnames from 'classnames';
import { action } from 'mobx';
import { observer } from 'mobx-react';
import $ from 'jquery';
import _ from 'lodash';

import { appActions } from 'fashionipo-services/es/actions';

import './BootstrapTable.scss';

var PAGE_SIZE = 20;

var BootstrapTable = observer(_class = (_temp2 = _class2 = function (_Component) {
  _inherits(BootstrapTable, _Component);

  function BootstrapTable() {
    var _temp, _this, _ret;

    _classCallCheck(this, BootstrapTable);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.handleSelectable = function ($table, $th) {
      var triggerCells = $table.find('> tbody > tr > td:nth-child(' + ($th.index() + 1) + ')');
      triggerCells.each(function (i, e) {
        var $e = $(e);
        if ($e.find('input').length > 0) return; // 如果已经有选择器了，跳出
        if ($e.prop('colspan') > 1) return; // 如果不是单独一列，退出，这种时候往往意味着没有数据
        $e.empty().append('<input type="checkbox" />').click(_this.handleSelectItem);
      });
      $th.empty().append('<input type="checkbox" />').click(_this.handleSelectAll);
    }, _this.handleSelectItem = function (e) {
      if (e.target.tagName !== 'INPUT') return;
      var $target = $(e.target);
      var cellIndex = $target.index() + 1;
      $target.parents('table').find('> thead > tr > th:nth-child(' + cellIndex + ') > input').prop('checked', false);
    }, _this.handleSelectAll = function (e) {
      var $target = $(e.currentTarget);
      var checked = $target.find('input').prop('checked');
      var cellIndex = $target.index() + 1;
      $target.parents('table').find('> tbody > tr > td:nth-child(' + cellIndex + ') > input').prop('checked', checked);
    }, _this.handleSort = function ($th) {
      var onSort = _this.props.onSort;

      var name = $th.data('field');
      var order = $th.data('order') || '+';
      onSort(name, order);
      _this.$table.find('.sortable').removeClass('asc').removeClass('desc');
      var $sort = $th.find('.sortable');
      if (order === '+') {
        $th.data('order', '-');
        $sort.removeClass('desc').addClass('asc');
      }
      if (order === '-') {
        $th.data('order', '+');
        $sort.removeClass('asc').addClass('desc');
      }
    }, _this.handlePage = function (page, size) {
      var onPage = _this.props.onPage;

      onPage(page, size);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  BootstrapTable.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var stickyHeader = this.props.stickyHeader;

    var $container = $(ReactDOM.findDOMNode(this.container));
    var $table = $container.find('table');
    $table.find("> thead > tr > th").each(function (i, th) {
      var $th = $(th);
      var title = $th.text();
      // 处理排序列
      var sortable = $th.data('sortable');
      if (sortable) {
        var wrapped = $('\n          <div class="th-inner">' + title + '</div>\n        ');
        wrapped.addClass('sortable both');
        wrapped.click(function () {
          return _this2.handleSort($th);
        });
        $th.empty().append(wrapped);
      }
      // 处理选择列
      var selectable = $th.data('selectable');
      if (selectable) {
        _this2.handleSelectable($table, $th);
        // 如果表格刷新，需要重新生成选择列
        appActions.resultSucceed.listen(function () {
          setTimeout(function () {
            return _this2.handleSelectable($table, $th);
          }, 0);
        });
      }
    });
    if (stickyHeader) {
      $table.stickyTableHeaders(); // {fixedOffset: 100}
      $container.find('.table-body').on('scroll', _.throttle(function () {
        return $(window).trigger('resize.stickyTableHeaders');
      }, 100));
    }
    this.$table = $table;
  };

  BootstrapTable.prototype.getRowSelection = function getRowSelection() {
    var selectedIndex = [];
    var $container = $(ReactDOM.findDOMNode(this.container));
    var $table = $container.find('table');
    $table.find("> tbody > tr > td > input:checked").each(function (i, input) {
      selectedIndex.push($(input).parents('tr').prop('rowIndex') - 2);
    });
    return selectedIndex;
  };

  BootstrapTable.prototype.render = function render() {
    var _this3 = this;

    var _props = this.props,
        className = _props.className,
        children = _props.children;

    return React.createElement(
      'div',
      { className: classnames("app-bootstrap-table", className), ref: function ref(el) {
          return _this3.container = el;
        } },
      React.createElement(
        'div',
        { className: 'table-container' },
        React.createElement(
          'div',
          { className: 'table-body' },
          children
        )
      ),
      React.createElement(Pagination, this.props)
    );
  };

  return BootstrapTable;
}(Component), _class2.defaultProps = {
  stickyHeader: false,
  activePage: 1,
  onSort: _.noop,
  onPage: _.noop
}, _temp2)) || _class;

export { BootstrapTable as default };
BootstrapTable.propTypes = process.env.NODE_ENV !== "production" ? {
  stickyHeader: PropTypes.bool,
  onSort: PropTypes.func,
  onPage: PropTypes.func,
  activePage: PropTypes.any
} : {};

var Pagination = observer(_class3 = (_class4 = function (_Component2) {
  _inherits(Pagination, _Component2);

  function Pagination() {
    var _temp3, _this4, _ret2;

    _classCallCheck(this, Pagination);

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret2 = (_temp3 = (_this4 = _possibleConstructorReturn(this, _Component2.call.apply(_Component2, [this].concat(args))), _this4), _this4.state = {
      page: _this4.props.activePage
    }, _initDefineProp(_this4, 'handleSelect', _descriptor, _this4), _this4.handlePageInput = function (e) {
      _this4.setState({ page: e.target.value });
    }, _this4.handlePageEnter = function (e) {
      if (e.key !== 'Enter') return;
      var onPage = _this4.props.onPage;
      var page = _this4.state.page;

      onPage(parseInt(page, 10), e);
    }, _temp3), _possibleConstructorReturn(_this4, _ret2);
  }

  Pagination.prototype.render = function render() {
    var _props2 = this.props,
        activePage = _props2.activePage,
        total = _props2.total;
    var page = this.state.page;

    if (!total) return null;
    /* eslint-disable */
    return React.createElement(
      'div',
      { className: 'table-pagination' },
      React.createElement(
        'div',
        { className: 'pull-left pagination-detail' },
        React.createElement(
          'span',
          { className: 'pagination-info' },
          '\u603B\u5171 ',
          total,
          ' \u6761\u8BB0\u5F55'
        )
      ),
      React.createElement(
        'div',
        { className: 'page-input' },
        '\u8DF3\u5230\u7B2C ',
        React.createElement(FormControl, { type: 'number', value: page, onChange: this.handlePageInput, onKeyPress: this.handlePageEnter }),
        ' \u9875'
      ),
      React.createElement(
        'div',
        { className: 'pull-right pagination' },
        React.createElement(_Pagination, { prev: true, next: true, first: true, last: true, ellipsis: true, boundaryLinks: true, items: Math.ceil(total / PAGE_SIZE),
          maxButtons: 5, onSelect: this.handleSelect, activePage: activePage })
      )
    );
  };

  return Pagination;
}(Component), (_descriptor = _applyDecoratedDescriptor(_class4.prototype, 'handleSelect', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this5 = this;

    return function (page, e) {
      // eslint-disable-next-line
      var _props3 = _this5.props,
          activePage = _props3.activePage,
          onPage = _props3.onPage;

      onPage(page, e);
      activePage = page;
    };
  }
})), _class4)) || _class3;

// <span className="page-list">每页显示 <span className="btn-group dropup"><button type="button" className="btn btn-default dropdown-toggle" data-toggle="dropdown"><span className="page-size">20</span> <span className="caret"></span></button><ul className="dropdown-menu" role="menu"></ul></span> 条记录</span>