var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import { Form } from 'react-bootstrap';
import classnames from 'classnames';
import $ from 'jquery';

import { Utils } from 'fashionipo-services/es/utility';

import './Box.scss';

var Box = (_temp = _class = function (_Component) {
  _inherits(Box, _Component);

  function Box() {
    _classCallCheck(this, Box);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Box.prototype._getBox = function _getBox() {
    if (this.$box) return this.$box;
    this.$box = $(ReactDOM.findDOMNode(this.box));
    return this.$box;
  };

  Box.prototype.collapse = function collapse() {
    this._getBox().boxWidget('collapse');
  };

  Box.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this._getBox().boxWidget();
    Utils.ifSmallScreen(function () {
      if (_this2.props.collapseOnSmallScreen) _this2.collapse();
    });
  };

  Box.prototype.render = function render() {
    var _this3 = this;

    var _props = this.props,
        children = _props.children,
        inline = _props.inline,
        horizontal = _props.horizontal,
        className = _props.className,
        id = _props.id,
        headerSlot = _props.headerSlot,
        collapseOnSmallScreen = _props.collapseOnSmallScreen,
        footerSlot = _props.footerSlot;

    var collapseClass = Utils.ifSmallScreen(function () {
      return collapseOnSmallScreen;
    });
    return React.createElement(
      Form,
      { id: id, inline: inline, horizontal: horizontal, className: classnames("app-box box box-primary", { 'collapsed-box': collapseClass }, className), ref: function ref(el) {
          return _this3.box = el;
        } },
      headerSlot && React.createElement(
        'div',
        { className: 'box-header with-border' },
        headerSlot,
        React.createElement(
          'div',
          { className: 'box-tools pull-right' },
          React.createElement(
            'button',
            { type: 'button', className: 'btn btn-box-tool', 'data-widget': 'collapse' },
            React.createElement('i', { className: 'fa fa-minus' })
          )
        )
      ),
      React.createElement(
        'div',
        { className: 'box-body' },
        children
      ),
      footerSlot && React.createElement(
        'div',
        { className: 'box-footer' },
        footerSlot
      )
    );
  };

  return Box;
}(Component), _class.defaultProps = {
  collapseOnSmallScreen: false
}, _temp);
export { Box as default };
Box.propTypes = process.env.NODE_ENV !== "production" ? {
  headerSlot: PropTypes.object,
  footerSlot: PropTypes.object,
  collapseOnSmallScreen: PropTypes.bool
} : {};