import React from 'react';

import './Card.css';

function Card(props) {
  return React.createElement(
    'div',
    { className: 'app-card ' + props.className },
    React.createElement(
      'div',
      { className: 'app-card-image-wrapper' },
      React.createElement('img', { className: 'app-card-image', src: props.imageSrc, alt: props.alt })
    ),
    React.createElement(
      'div',
      { className: 'app-card-body' },
      React.createElement(
        'div',
        { className: 'app-card-title' },
        props.title
      ),
      React.createElement(
        'div',
        { className: 'app-card-subtitle' },
        props.subtitle
      ),
      React.createElement(
        'p',
        { className: 'app-card-text' },
        props.text
      ),
      React.createElement(
        'div',
        { className: 'app-card-status' },
        props.statusText
      )
    )
  );
}

export default Card;