var _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp2;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Modal, Button } from 'react-bootstrap';
import classnames from 'classnames';
import { observable, action } from 'mobx';
import { observer } from 'mobx-react';
import browser from 'bowser';
import $ from 'jquery';
import _ from 'lodash';
import './PickerDialog.scss';

var PickerDialog = observer(_class = (_class2 = (_temp2 = _class3 = function (_Component) {
  _inherits(PickerDialog, _Component);

  function PickerDialog() {
    var _temp, _this, _ret;

    _classCallCheck(this, PickerDialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _initDefineProp(_this, 'showModal', _descriptor, _this), _initDefineProp(_this, 'show', _descriptor2, _this), _initDefineProp(_this, 'hide', _descriptor3, _this), _this.handleOk = function () {
      _this.props.onOk();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  PickerDialog.prototype.render = function render() {
    var _props = this.props,
        title = _props.title,
        size = _props.size,
        leftButton = _props.leftButton,
        rightButton = _props.rightButton,
        className = _props.className,
        position = _props.position,
        children = _props.children;

    return React.createElement(
      Modal,
      { show: this.showModal, onHide: this.hide, bsSize: size, dialogClassName: classnames('app-picker-dialog-' + position, className) },
      title && React.createElement(
        Modal.Header,
        null,
        React.createElement(
          'div',
          { className: 'pull-left' },
          leftButton ? leftButton : React.createElement(
            Button,
            { onClick: this.hide },
            '\u53D6\u6D88'
          )
        ),
        React.createElement(
          'div',
          { className: 'pull-right' },
          rightButton ? rightButton : React.createElement(
            Button,
            { bsStyle: 'primary', onClick: this.handleOk },
            '\u786E\u5B9A'
          )
        ),
        React.createElement(
          Modal.Title,
          { className: 'text-center' },
          title
        )
      ),
      React.createElement(
        Modal.Body,
        null,
        children
      )
    );
  };

  return PickerDialog;
}(Component), _class3.defaultProps = {
  position: 'bottom',
  onOk: _.noop,
  onCancel: _.noop
}, _temp2), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'showModal', [observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'show', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this2 = this;

    return function () {
      _this2.showModal = true;
      if (browser.safari) {
        setTimeout(function () {
          var $dialog = $('.app-picker-dialog');
          $dialog.css('top', '100% - ' + $dialog.height() + 'px');
        }, 0);
      }
    };
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'hide', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this3 = this;

    return function () {
      _this3.props.onCancel();
      _this3.showModal = false;
    };
  }
})), _class2)) || _class;

export { PickerDialog as default };
PickerDialog.propTypes = process.env.NODE_ENV !== "production" ? {
  title: PropTypes.string,
  position: PropTypes.string,
  size: PropTypes.string,
  onOk: PropTypes.func,
  onCancel: PropTypes.func
} : {};