var _class;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import { Form, FormControl } from 'react-bootstrap';
import { observer } from 'mobx-react';
import $ from 'jquery';

import Dialog from './Dialog';

import './PromptDialog.scss';

var PromptDialog = observer(_class = function (_Component) {
  _inherits(PromptDialog, _Component);

  function PromptDialog() {
    var _temp, _this, _ret;

    _classCallCheck(this, PromptDialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.handleOk = function (dialog, resolve) {
      var $input = $(ReactDOM.findDOMNode(_this.input));
      resolve($input.val());
      dialog.hide();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  PromptDialog.prototype.show = function show() {
    var _this2 = this;

    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    opts = {
      title: opts.title || '请输入',
      size: opts.size || 'lg',
      control: opts.control || 'input',
      placeholder: undefined
    };
    return new Promise(function (resolve) {
      _this2.dialog.show({
        title: opts.title,
        body: _this2._renderDialog(opts.control, opts.placeholder),
        bsSize: opts.size,
        actions: [Dialog.CancelAction(), Dialog.DefaultAction('确定', function (dialog) {
          return _this2.handleOk(dialog, resolve);
        })]
      });
    });
  };

  PromptDialog.prototype._renderDialog = function _renderDialog(control, placeholder) {
    var _this3 = this;

    return React.createElement(
      'div',
      { className: 'app-prompt-dialog' },
      React.createElement(
        Form,
        null,
        control !== 'textarea' && React.createElement(FormControl, { ref: function ref(el) {
            return _this3.input = el;
          }, placeholder: placeholder }),
        control === 'textarea' && React.createElement(FormControl, { componentClass: 'textarea', ref: function ref(el) {
            return _this3.input = el;
          }, placeholder: placeholder })
      )
    );
  };

  PromptDialog.prototype.render = function render() {
    var _this4 = this;

    return React.createElement(Dialog, { ref: function ref(el) {
        return _this4.dialog = el;
      } });
  };

  return PromptDialog;
}(Component)) || _class;

export { PromptDialog as default };