var _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp2;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Modal, Glyphicon } from 'react-bootstrap';
import ReactPlayer from 'react-player';
import classnames from 'classnames';
import { observable, action } from 'mobx';
import { observer } from 'mobx-react';

import './VideoDialog.scss';

var VideoDialog = observer(_class = (_class2 = (_temp2 = _class3 = function (_Component) {
  _inherits(VideoDialog, _Component);

  function VideoDialog() {
    var _temp, _this, _ret;

    _classCallCheck(this, VideoDialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _initDefineProp(_this, 'showModal', _descriptor, _this), _initDefineProp(_this, 'show', _descriptor2, _this), _initDefineProp(_this, 'hide', _descriptor3, _this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  VideoDialog.prototype.render = function render() {
    var _props = this.props,
        src = _props.src,
        className = _props.className;

    return React.createElement(
      Modal,
      { show: this.showModal, onHide: this.hide, bsSize: 'lg', dialogClassName: classnames('app-video-dialog', className) },
      React.createElement(
        Modal.Body,
        { onClick: this.hide },
        React.createElement(ReactPlayer, { url: src, controls: true, style: { margin: '0 auto', width: 'auto', height: 'auto' } }),
        React.createElement(Glyphicon, { glyph: 'remove-circle' })
      )
    );
  };

  return VideoDialog;
}(Component), _class3.defaultProps = {}, _temp2), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'showModal', [observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'show', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this2 = this;

    return function () {
      _this2.showModal = true;
    };
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'hide', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this3 = this;

    return function (e) {
      if (e && e.target.tagName === 'VIDEO') return;
      _this3.showModal = false;
    };
  }
})), _class2)) || _class;

export { VideoDialog as default };
VideoDialog.propTypes = process.env.NODE_ENV !== "production" ? {
  src: PropTypes.string
} : {};