var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _class3, _temp2;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { FormGroup, ControlLabel, FormControl, InputGroup, HelpBlock, Button, Col, Glyphicon } from 'react-bootstrap';
import browser from 'bowser';
import classnames from 'classnames';
import { observable, action } from 'mobx';
import { inject, observer } from 'mobx-react';
import _ from 'lodash';

import BrandFieldPicker from './BrandFieldPicker';
import BrandFieldDialog from './BrandFieldDialog';
import './BrandField.scss';

var BrandField = (_dec = inject('utilService', 'categoryStore'), _dec(_class = observer(_class = (_class2 = (_temp2 = _class3 = function (_Component) {
  _inherits(BrandField, _Component);

  function BrandField() {
    var _temp, _this, _ret;

    _classCallCheck(this, BrandField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.utilService = _this.props.utilService, _this.categoryStore = _this.props.categoryStore, _this.picker = new BrandFieldPicker(_this.utilService, _this.categoryStore, _this.handleChange), _initDefineProp(_this, 'displayValue', _descriptor, _this), _this.handlePicker = function () {
      if (browser.ios || browser.android) {
        _this.picker.showPicker();
      } else {
        _this.dialog.wrappedInstance.show();
      }
    }, _initDefineProp(_this, 'handleChange', _descriptor2, _this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  BrandField.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        id = _props.id,
        label = _props.label,
        placeholder = _props.placeholder,
        type = _props.type,
        inputSize = _props.inputSize,
        state = _props.state,
        componentClass = _props.componentClass,
        className = _props.className;


    return React.createElement(
      'div',
      { id: id, className: classnames("app-brand-field", className) },
      React.createElement(
        FormGroup,
        { validationState: state.hasError ? 'error' : null },
        label && React.createElement(
          Col,
          { componentClass: ControlLabel, md: 12 - inputSize, sm: 2, className: 'text-nowrap' },
          label
        ),
        React.createElement(
          Col,
          { md: inputSize, sm: 10, onClick: this.handlePicker },
          React.createElement(
            InputGroup,
            null,
            React.createElement(FormControl, { type: type, placeholder: placeholder, componentClass: componentClass,
              value: this.displayValue, readOnly: true }),
            React.createElement(
              InputGroup.Button,
              null,
              React.createElement(
                Button,
                { bsStyle: state.hasError ? 'danger' : 'default' },
                React.createElement(Glyphicon, { glyph: 'menu-down' })
              )
            )
          ),
          state.hasError && React.createElement(
            HelpBlock,
            { className: 'app-margin-left' },
            state.error
          )
        )
      ),
      React.createElement(BrandFieldDialog, { ref: function ref(el) {
          return _this2.dialog = el;
        }, onOk: this.handleChange })
    );
  };

  return BrandField;
}(Component), _class3.defaultProps = {
  inputSize: 10,
  state: {
    value: '',
    onChange: _.noop
  }
}, _temp2), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'displayValue', [observable], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'handleChange', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this3 = this;

    return function (value) {
      var state = _this3.props.state;

      _this3.displayValue = value ? value.brand.name + " + " + value.serie.name : '';
      state.onChange(value);
    };
  }
})), _class2)) || _class) || _class);
export { BrandField as default };
BrandField.propTypes = process.env.NODE_ENV !== "production" ? {
  label: PropTypes.string,
  placeholder: PropTypes.string,
  inputSize: PropTypes.number,
  state: PropTypes.object
} : {};