import _regeneratorRuntime from 'babel-runtime/regenerator';

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _class3, _temp2;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Form, FormGroup, ControlLabel, FormControl, Col } from 'react-bootstrap';
import { observable, action, runInAction } from 'mobx';
import { observer, inject } from 'mobx-react';
import _ from 'lodash';

import { PickerDialog } from '../dialog';

var BrandFieldDialog = (_dec = inject('utilService', 'categoryStore'), _dec(_class = observer(_class = (_class2 = (_temp2 = _class3 = function (_Component) {
  _inherits(BrandFieldDialog, _Component);

  function BrandFieldDialog() {
    var _temp, _this, _ret;

    _classCallCheck(this, BrandFieldDialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.utilService = _this.props.utilService, _this.categoryStore = _this.props.categoryStore, _initDefineProp(_this, '_brands', _descriptor, _this), _initDefineProp(_this, '_series', _descriptor2, _this), _initDefineProp(_this, 'brand', _descriptor3, _this), _initDefineProp(_this, 'serie', _descriptor4, _this), _initDefineProp(_this, '_handleBrandChange', _descriptor5, _this), _initDefineProp(_this, '_handleSerieChange', _descriptor6, _this), _this.handleOk = function () {
      var result = void 0;
      if (_this.serie) result = {
        brand: { code: _this.brand, name: _this.brandName },
        serie: { code: _this.serie, name: _this.serieName }
      };
      _this.props.onOk(result);
      _this.dialog.hide();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  BrandFieldDialog.prototype._loadBrands = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var _this2 = this;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this.categoryStore.getCategoriesWithChildren();

            case 2:
              this._source = _context.sent;

              runInAction(function () {
                return _this2._brands = _this2._source.filter(function (category) {
                  return category.parentCode === 'sbr';
                });
              });

            case 4:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function _loadBrands() {
      return _ref.apply(this, arguments);
    }

    return _loadBrands;
  }();

  BrandFieldDialog.prototype._loadSeries = function _loadSeries(code) {
    this.serie = '';
    this._series = this._source.filter(function (category) {
      return category.parentCode === code;
    });
  };

  BrandFieldDialog.prototype._getName = function _getName(e) {
    var index = e.nativeEvent.target.selectedIndex;
    return e.nativeEvent.target[index].text;
  };

  BrandFieldDialog.prototype.show = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              this.dialog.show();
              if (!this._source) this._loadBrands();

            case 2:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function show() {
      return _ref2.apply(this, arguments);
    }

    return show;
  }();

  BrandFieldDialog.prototype.render = function render() {
    var _this3 = this;

    return React.createElement(
      PickerDialog,
      { title: '\u8BF7\u9009\u62E9\u54C1\u724C\u7CFB\u5217', ref: function ref(el) {
          return _this3.dialog = el;
        }, className: 'app-brand-field-dialog', position: 'top', onOk: this.handleOk },
      React.createElement(
        Form,
        { horizontal: true },
        React.createElement(
          FormGroup,
          null,
          React.createElement(
            Col,
            { componentClass: ControlLabel, md: 1, className: 'text-nowrap' },
            '\u54C1\u724C'
          ),
          React.createElement(
            Col,
            { md: 5 },
            React.createElement(
              FormControl,
              { componentClass: 'select', placeholder: '-\u8BF7\u9009\u62E9\u54C1\u724C-',
                value: this.brand, onChange: this._handleBrandChange },
              !this._brands && React.createElement(
                'option',
                { value: '' },
                '\u6B63\u5728\u52A0\u8F7D\u54C1\u724C\u6570\u636E\u2026\u2026'
              ),
              React.createElement(
                'option',
                { value: '' },
                '-\u8BF7\u9009\u62E9\u54C1\u724C-'
              ),
              this._brands && this._brands.map(function (brand) {
                return React.createElement(
                  'option',
                  { key: brand.code, value: brand.code },
                  brand.name
                );
              })
            )
          ),
          React.createElement(
            Col,
            { componentClass: ControlLabel, md: 1, className: 'text-nowrap' },
            '\u7CFB\u5217'
          ),
          React.createElement(
            Col,
            { md: 5 },
            React.createElement(
              FormControl,
              { componentClass: 'select', placeholder: '-\u8BF7\u9009\u62E9\u54C1\u724C-',
                value: this.serie, onChange: this._handleSerieChange },
              React.createElement(
                'option',
                { value: '' },
                '-\u8BF7\u9009\u62E9\u7CFB\u5217-'
              ),
              this._series && this._series.map(function (serie) {
                return React.createElement(
                  'option',
                  { key: serie.code, value: serie.code },
                  serie.name
                );
              })
            )
          )
        )
      )
    );
  };

  return BrandFieldDialog;
}(Component), _class3.defaultProps = {
  onOk: _.noop
}, _temp2), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, '_brands', [observable], {
  enumerable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, '_series', [observable], {
  enumerable: true,
  initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'brand', [observable], {
  enumerable: true,
  initializer: null
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'serie', [observable], {
  enumerable: true,
  initializer: null
}), _applyDecoratedDescriptor(_class2.prototype, '_loadSeries', [action], Object.getOwnPropertyDescriptor(_class2.prototype, '_loadSeries'), _class2.prototype), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, '_handleBrandChange', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this4 = this;

    return function (e) {
      _this4.brand = e.target.value;
      _this4.brandName = _this4._getName(e);
      _this4._loadSeries(e.target.value);
    };
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, '_handleSerieChange', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this5 = this;

    return function (e) {
      _this5.serie = e.target.value;
      _this5.serieName = _this5._getName(e);
    };
  }
})), _class2)) || _class) || _class);
export { BrandFieldDialog as default };
BrandFieldDialog.propTypes = process.env.NODE_ENV !== "production" ? {
  onOk: PropTypes.func
} : {};