import _regeneratorRuntime from 'babel-runtime/regenerator';

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp2;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { observable, action, reaction, runInAction } from 'mobx';
import { observer, inject } from 'mobx-react';

var BrandFieldHelper = (_dec = inject('utilService', 'categoryStore'), _dec(_class = observer(_class = (_class2 = (_temp2 = _class3 = function (_Component) {
  _inherits(BrandFieldHelper, _Component);

  function BrandFieldHelper() {
    var _temp, _this, _ret;

    _classCallCheck(this, BrandFieldHelper);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.utilService = _this.props.utilService, _this.categoryStore = _this.props.categoryStore, _initDefineProp(_this, '_brands', _descriptor, _this), _initDefineProp(_this, '_series', _descriptor2, _this), _initDefineProp(_this, '_handleBrandChange', _descriptor3, _this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  BrandFieldHelper.prototype.componentDidMount = function componentDidMount() {
    this._loadBrands();
  };

  BrandFieldHelper.prototype._loadBrands = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var _this2 = this;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this.categoryStore.getCategoriesWithChildren();

            case 2:
              this._source = _context.sent;

              runInAction(function () {
                _this2._brands = _this2._source.filter(function (category) {
                  return category.parentCode === 'sbr';
                });
              });
              reaction(function () {
                return _this2.props.brandCode;
              }, function (code) {
                return _this2._loadSeries(code.$);
              } // 从列表页进入的时候会调用这里
              );
              if (this.props.brandCode) {
                this._loadSeries(this.props.brandCode.$); // 直接刷新的时候会调用这里
              }

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function _loadBrands() {
      return _ref.apply(this, arguments);
    }

    return _loadBrands;
  }();

  BrandFieldHelper.prototype._loadSeries = function _loadSeries(code) {
    if (!code) return;
    this._series = this._source.filter(function (category) {
      return category.parentCode === code;
    });
  };

  BrandFieldHelper.prototype.render = function render() {
    var children = this.props.children;

    return React.createElement(
      'div',
      null,
      children({
        brands: this._brands,
        series: this._series,
        handleBrandChange: this._handleBrandChange
      })
    );
  };

  return BrandFieldHelper;
}(Component), _class3.defaultProps = {}, _temp2), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, '_brands', [observable], {
  enumerable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, '_series', [observable], {
  enumerable: true,
  initializer: null
}), _applyDecoratedDescriptor(_class2.prototype, '_loadSeries', [action], Object.getOwnPropertyDescriptor(_class2.prototype, '_loadSeries'), _class2.prototype), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, '_handleBrandChange', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this3 = this;

    return function (e, serieState) {
      _this3._loadSeries(e.target.value);
      if (serieState) serieState.reinitValue('');
    };
  }
})), _class2)) || _class) || _class);
export { BrandFieldHelper as default };
BrandFieldHelper.propTypes = process.env.NODE_ENV !== "production" ? {
  brandCode: PropTypes.object
} : {};