var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _desc, _value, _class2, _descriptor, _descriptor2, _class3, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import { FormGroup, InputGroup, FormControl, Col, HelpBlock, ControlLabel, Glyphicon } from 'react-bootstrap';
import classnames from 'classnames';
import { observable, action } from 'mobx';
import { observer } from 'mobx-react';
import $ from 'jquery';
import _ from 'lodash';
import moment from 'moment';

import { Utils } from 'fashionipo-services/es/utility';

import 'bootstrap-daterangepicker/daterangepicker.scss';
import './DateRangeField.scss';

var LOCALE = {
  "applyLabel": "确定",
  "cancelLabel": "清空",
  "fromLabel": "从",
  "toLabel": "到",
  "customRangeLabel": "定制",
  "weekLabel": "W",
  "daysOfWeek": ["日", "一", "二", "三", "四", "五", "六"],
  "monthNames": ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"],
  firstDay: 1
};

var DateRangeField = observer(_class = (_class2 = (_temp2 = _class3 = function (_Component) {
  _inherits(DateRangeField, _Component);

  function DateRangeField() {
    var _temp, _this, _ret;

    _classCallCheck(this, DateRangeField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _initDefineProp(_this, 'handleChange', _descriptor, _this), _this.handleApply = function () {
      _this.handleChange(_this.picker.startDate, _this.picker.endDate);
    }, _initDefineProp(_this, 'handleClear', _descriptor2, _this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  DateRangeField.prototype.initDateRange = function initDateRange() {
    var $dateRange = $(ReactDOM.findDOMNode(this.dateRange));
    var prerange = this.props.prerange;

    var ranges = {
      "今天": [moment(), moment().add(1, 'days')],
      "过去1天": [moment().subtract(1, 'days'), moment()],
      "过去7天": [moment().subtract(6, 'days'), moment()],
      "过去30天": [moment().subtract(29, 'days'), moment()],
      "这个月": [moment().startOf('month'), moment().endOf('month')],
      "上个月": [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
    };
    if (prerange === 'future') {
      ranges = {
        "今天": [moment(), moment().add(1, 'days')],
        "未来7天": [moment(), moment().add(6, 'days')],
        "未来30天": [moment(), moment().add(29, 'days')],
        "这个月": [moment().startOf('month'), moment().endOf('month')],
        "下个月": [moment().add(1, 'month').startOf('month'), moment().add(1, 'month').endOf('month')]
      };
    }
    $dateRange.daterangepicker({
      opens: "left",
      autoUpdateInput: false,
      locale: LOCALE,
      alwaysShowCalendars: true,
      showCustomRangeLabel: false,
      ranges: ranges
    });
    this.picker = $dateRange.data().daterangepicker;
    $dateRange.on('apply.daterangepicker', this.handleApply);
    $dateRange.on('cancel.daterangepicker', this.handleClear);
  };

  DateRangeField.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.handleClear();
    setTimeout(function () {
      return _this2.initDateRange();
    }, 0);
  };

  DateRangeField.prototype.render = function render() {
    var _this3 = this;

    var _props = this.props,
        id = _props.id,
        label = _props.label,
        placeholder = _props.placeholder,
        state = _props.state,
        withLabel = _props.withLabel,
        inputSize = _props.inputSize,
        className = _props.className,
        otherProps = _objectWithoutProperties(_props, ['id', 'label', 'placeholder', 'state', 'withLabel', 'inputSize', 'className']);

    if (withLabel) {
      return React.createElement(
        'div',
        { id: id, className: classnames("app-daterange-field", className) },
        React.createElement(
          FormGroup,
          { validationState: state.hasError ? 'error' : null },
          label && React.createElement(
            Col,
            { componentClass: ControlLabel, md: 12 - inputSize, sm: 2, className: 'text-nowrap' },
            label
          ),
          React.createElement(
            Col,
            { md: inputSize, sm: 10 },
            React.createElement(FormControl, _extends({ type: 'text', value: state.value,
              readOnly: true, placeholder: placeholder, ref: function ref(_ref) {
                return _this3.dateRange = _ref;
              } }, otherProps)),
            state.hasError && React.createElement(
              HelpBlock,
              { className: 'app-margin-left' },
              React.createElement(Glyphicon, { glyph: 'info-sign' }),
              ' ',
              state.error
            )
          )
        )
      );
    }

    return React.createElement(
      'span',
      { className: 'app-daterange-field' },
      React.createElement(
        FormGroup,
        null,
        React.createElement(
          InputGroup,
          null,
          React.createElement(FormControl, _extends({ type: 'text', value: state.value,
            readOnly: true, placeholder: placeholder, ref: function ref(_ref2) {
              return _this3.dateRange = _ref2;
            } }, otherProps))
        )
      )
    );
  };

  return DateRangeField;
}(Component), _class3.defaultProps = {
  rangetype: 'date',
  prerange: 'past',
  state: observable({ value: '', onChange: _.noop }),
  onChange: _.noop
}, _temp2), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'handleChange', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this4 = this;

    return function (start, end, label) {
      var _props2 = _this4.props,
          state = _props2.state,
          onChange = _props2.onChange;

      state.value = Utils.formatDate(start) + ' - ' + Utils.formatDate(end);
      state.onChange(state.value);
      state.start = start;
      state.end = end;
      onChange({ start: start, end: end, label: label });
    };
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'handleClear', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this5 = this;

    return function () {
      var _props3 = _this5.props,
          state = _props3.state,
          onChange = _props3.onChange;

      state.value = '';
      delete state.start;
      delete state.end;
      onChange({ clear: true });
    };
  }
})), _class2)) || _class;

export { DateRangeField as default };
DateRangeField.propTypes = process.env.NODE_ENV !== "production" ? {
  placeholder: PropTypes.string,
  state: PropTypes.object,
  rangetype: PropTypes.string,
  onChange: PropTypes.func,
  prerange: PropTypes.oneOf(['past', 'future'])
} : {};