var _class, _class2, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { FormGroup, ControlLabel, HelpBlock, Col } from 'react-bootstrap';
import Datetime from 'react-datetime';
import classnames from 'classnames';
import { observer } from 'mobx-react';
import _ from 'lodash';

import 'react-datetime/css/react-datetime.css';
import './DateTimeField.scss';

var DateTimeField = observer(_class = (_temp = _class2 = function (_Component) {
  _inherits(DateTimeField, _Component);

  function DateTimeField() {
    _classCallCheck(this, DateTimeField);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  DateTimeField.prototype.render = function render() {
    var _props = this.props,
        id = _props.id,
        label = _props.label,
        placeholder = _props.placeholder,
        type = _props.type,
        readOnly = _props.readOnly,
        inputSize = _props.inputSize,
        state = _props.state,
        tabIndex = _props.tabIndex,
        className = _props.className;


    var dateFormat = 'YYYY/MM/DD',
        timeFormat = 'HH:mm';
    if (type === "date") timeFormat = false;
    if (type === "time") dateFormat = false;

    return React.createElement(
      'div',
      { id: id, className: classnames("app-datetime-field", className) },
      React.createElement(
        FormGroup,
        { validationState: state.hasError ? 'error' : null },
        label && React.createElement(
          Col,
          { componentClass: ControlLabel, md: 12 - inputSize, sm: 2, className: 'text-nowrap' },
          label
        ),
        React.createElement(
          Col,
          { md: inputSize, sm: 10 },
          React.createElement(Datetime, { dateFormat: dateFormat, timeFormat: timeFormat,
            value: state.value, onChange: state.onChange,
            inputProps: { placeholder: placeholder, readOnly: readOnly, tabIndex: tabIndex },
            utc: true, closeOnSelect: true }),
          state.hasError && React.createElement(
            HelpBlock,
            { className: 'app-margin-left' },
            state.error
          )
        )
      )
    );
  };

  return DateTimeField;
}(Component), _class2.defaultProps = {
  type: 'date',
  inputSize: 10,
  readOnly: false,
  state: {
    value: '',
    onChange: _.noop
  }
}, _temp)) || _class;

export { DateTimeField as default };
DateTimeField.propTypes = process.env.NODE_ENV !== "production" ? {
  label: PropTypes.string,
  placeholder: PropTypes.string,
  state: PropTypes.object,
  type: PropTypes.string,
  inputSize: PropTypes.number,
  readOnly: PropTypes.bool
} : {};