import _regeneratorRuntime from 'babel-runtime/regenerator';

var _dec, _class, _desc, _value, _class2, _descriptor, _class3, _temp2;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { FormGroup, ControlLabel, Col, Glyphicon, HelpBlock } from 'react-bootstrap';
import classnames from 'classnames';
import Dropzone from 'react-dropzone';
import { observable, action } from 'mobx';
import { observer, inject } from 'mobx-react';
import _ from 'lodash';

import { Utils } from 'fashionipo-services/es/utility';
import { LightBox } from '../lightbox';

import './ImageField.scss';

var ImageField = (_dec = inject('utilService', 'fileService'), _dec(_class = observer(_class = (_class2 = (_temp2 = _class3 = function (_Component) {
  _inherits(ImageField, _Component);

  function ImageField() {
    var _temp, _this, _ret;

    _classCallCheck(this, ImageField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.previews = {}, _this.files = {}, _this.utilService = _this.props.utilService, _this.fileService = _this.props.fileService, _this.handleDrop = function (acceptedFiles, rejectedFiles) {
      var _this$props = _this.props,
          state = _this$props.state,
          multiple = _this$props.multiple;

      acceptedFiles.forEach(function (file) {
        var fileKey = file.name.replace('.', '_');
        if (multiple) {
          _this.previews[fileKey] = file.preview;
          _this.files[fileKey] = file;
          state.value[fileKey] = true;
          state.onChange(state.value);
        } else {
          var _this$previews, _this$files;

          _this.previews = (_this$previews = {}, _this$previews[fileKey] = file.preview, _this$previews);
          _this.files = (_this$files = {}, _this$files[fileKey] = file, _this$files);
          state.onChange(_this.previews);
        }
      });
      _this.forceUpdate();
    }, _this.handleClick = function (e) {
      if (e.target.tagName === 'IMG' || e.target.tagName === 'SPAN') return;
      _this.dropzone.open();
    }, _initDefineProp(_this, 'handleRemove', _descriptor, _this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  ImageField.prototype.prepare = function prepare(props) {
    var _this2 = this;

    var state = props.state;

    _.forEach(state.value, function (img, k) {
      _this2.previews[k] = img.original;
    });
  };

  ImageField.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (!Utils.isEmpty(this.previews)) return;
    this.prepare(nextProps);
    this.forceUpdate();
  };

  ImageField.prototype.upload = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var state, filenames, i, l, file, formData, result;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              state = this.props.state;

              if (!Utils.isEmpty(this.files)) {
                _context.next = 4;
                break;
              }

              state.onChange({});
              return _context.abrupt('return');

            case 4:
              this.utilService.spinnerAutoHide = false;
              this.utilService.showSpinner('正在上传图片...');
              filenames = _.keys(this.files);
              i = 0, l = filenames.length;

            case 8:
              if (!(i < l)) {
                _context.next = 19;
                break;
              }

              file = this.files[filenames[i]];
              formData = new FormData();

              formData.append('file', file);
              _context.next = 14;
              return this.fileService.upload(formData);

            case 14:
              result = _context.sent;

              state.value[filenames[i]] = result.message;

            case 16:
              i++;
              _context.next = 8;
              break;

            case 19:
              state.onChange(state.value);
              this.utilService.spinnerAutoHide = true;
              this.utilService.hideSpinner();

            case 22:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function upload() {
      return _ref.apply(this, arguments);
    }

    return upload;
  }();

  ImageField.prototype.componentWillUnmount = function componentWillUnmount() {
    _.map(this.previews, function (imgSrc) {
      return window.URL.revokeObjectURL(imgSrc);
    });
  };

  ImageField.prototype.render = function render() {
    var _this3 = this;

    var _props = this.props,
        label = _props.label,
        className = _props.className,
        placeholder = _props.placeholder,
        multiple = _props.multiple,
        inputSize = _props.inputSize,
        withLabel = _props.withLabel,
        removeable = _props.removeable,
        state = _props.state;

    var left = 0;
    var input = React.createElement(
      Dropzone,
      { className: 'app-image-field-dropzone', ref: function ref(el) {
          return _this3.dropzone = el;
        },
        onDrop: this.handleDrop, disableClick: true, multiple: multiple, accept: 'image/*', maxSize: 20 * 1024 * 1024 },
      !Utils.isEmpty(this.previews) ? React.createElement(
        'div',
        { onClick: this.handleClick },
        _.map(this.previews, function (imgSrc, filename) {
          var img = React.createElement(LightBox, { key: filename, filename: filename, src: imgSrc, fullSrc: imgSrc,
            style: { left: left + 'px' }, responsive: true,
            removeable: removeable, onRemove: _this3.handleRemove });
          left += 35;
          return img;
        })
      ) : React.createElement(
        'p',
        { className: 'app-padding', onClick: this.handleClick },
        placeholder
      )
    );
    if (!withLabel) {
      return React.createElement(
        'div',
        { className: classnames("app-image-field", className, state.hasError ? 'error' : null) },
        input
      );
    }
    return React.createElement(
      'div',
      { className: classnames("app-image-field", className) },
      React.createElement(
        FormGroup,
        { validationState: state.hasError ? 'error' : null },
        label && React.createElement(
          Col,
          { componentClass: ControlLabel, md: 12 - inputSize, sm: 2, className: 'text-nowrap' },
          label
        ),
        React.createElement(
          Col,
          { md: inputSize, sm: 10 },
          input,
          state.hasError && React.createElement(
            HelpBlock,
            { className: 'app-margin-left' },
            React.createElement(Glyphicon, { glyph: 'info-sign' }),
            ' ',
            state.error
          )
        )
      )
    );
  };

  return ImageField;
}(Component), _class3.defaultProps = {
  placeholder: '拖拽或者点击选择图片',
  removeable: false,
  state: observable({
    value: {},
    onChange: _.noop
  })
}, _temp2), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'handleRemove', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this4 = this;

    return function (filename) {
      var state = _this4.props.state;

      delete _this4.previews[filename];
      delete _this4.files[filename];
      delete state.value[filename];
      state.onChange(state.value);
      _this4.forceUpdate();
    };
  }
})), _class2)) || _class) || _class);
export { ImageField as default };
ImageField.propTypes = process.env.NODE_ENV !== "production" ? {
  placeholder: PropTypes.string,
  removeable: PropTypes.bool,
  state: PropTypes.object
} : {};