var _class, _class2, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import { FormGroup, ControlLabel, FormControl, InputGroup, HelpBlock, Col, Glyphicon } from 'react-bootstrap';
import { Checkbox } from 'react-icheck';
import Inputmask from "inputmask";
import classnames from 'classnames';
import { observer } from 'mobx-react';
import _ from 'lodash';

import 'inputmask/css/inputmask.css';
import 'icheck/skins/square/blue.css';
import './InputField.scss';

var InputField = observer(_class = (_temp = _class2 = function (_Component) {
  _inherits(InputField, _Component);

  function InputField() {
    _classCallCheck(this, InputField);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  InputField.prototype.componentDidMount = function componentDidMount() {
    if (!this.inputEl) return;
    if (this.props.mask) {
      var el = ReactDOM.findDOMNode(this.inputEl);
      var im = new Inputmask(this.props.mask);
      im.mask(el);
    }
  };

  InputField.prototype._renderAsLabel = function _renderAsLabel() {
    var _props = this.props,
        label = _props.label,
        text = _props.text,
        className = _props.className,
        inputSize = _props.inputSize;

    return React.createElement(
      'div',
      { className: classnames("app-input-field", className) },
      React.createElement(
        FormGroup,
        null,
        label && React.createElement(
          Col,
          { componentClass: ControlLabel, md: 12 - inputSize, sm: 2, className: 'text-nowrap' },
          label
        ),
        React.createElement(
          Col,
          { md: inputSize, sm: 10 },
          React.createElement(
            'p',
            { className: 'form-control-static' },
            text
          )
        )
      )
    );
  };

  InputField.prototype._renderNormal = function _renderNormal() {
    var _props2 = this.props,
        label = _props2.label,
        placeholder = _props2.placeholder,
        type = _props2.type,
        size = _props2.size,
        state = _props2.state;


    return React.createElement(
      'div',
      { className: 'app-input-field' },
      React.createElement(
        FormGroup,
        { validationState: state.hasError ? 'error' : null },
        label && React.createElement(
          ControlLabel,
          null,
          label
        ),
        React.createElement(FormControl, { type: type, placeholder: placeholder, bsSize: size,
          value: state.value, onChange: function onChange(e) {
            return state.onChange(e.target.value);
          } }),
        state.hasError && React.createElement(
          HelpBlock,
          { className: 'app-margin-left' },
          React.createElement(Glyphicon, { glyph: 'info-sign' }),
          ' ',
          state.error
        )
      )
    );
  };

  InputField.prototype._renderWithLabel = function _renderWithLabel() {
    var _this2 = this;

    var _props3 = this.props,
        id = _props3.id,
        label = _props3.label,
        placeholder = _props3.placeholder,
        type = _props3.type,
        readOnly = _props3.readOnly,
        addonLeft = _props3.addonLeft,
        addonRight = _props3.addonRight,
        inputSize = _props3.inputSize,
        state = _props3.state,
        componentClass = _props3.componentClass,
        tabIndex = _props3.tabIndex,
        className = _props3.className,
        disabled = _props3.disabled;


    var input = React.createElement(FormControl, { type: type, placeholder: placeholder, componentClass: componentClass, tabIndex: tabIndex, readOnly: readOnly, disabled: disabled,
      value: state.value, onChange: function onChange(e) {
        return state.onChange(e.target.value);
      }, ref: function ref(el) {
        _this2.inputEl = el;
      } });
    if (addonLeft) {
      input = React.createElement(
        InputGroup,
        null,
        React.createElement(
          InputGroup.Addon,
          null,
          addonLeft
        ),
        input
      );
    }
    if (addonRight) {
      input = React.createElement(
        InputGroup,
        null,
        input,
        React.createElement(
          InputGroup.Addon,
          null,
          addonRight
        )
      );
    }

    return React.createElement(
      'div',
      { id: id, className: classnames("app-input-field", className) },
      React.createElement(
        FormGroup,
        { validationState: state.hasError ? 'error' : null },
        label && React.createElement(
          Col,
          { componentClass: ControlLabel, md: 12 - inputSize, sm: 2, className: 'text-nowrap' },
          label
        ),
        React.createElement(
          Col,
          { md: inputSize, sm: 10 },
          input,
          state.hasError && React.createElement(
            HelpBlock,
            { className: 'app-margin-left' },
            React.createElement(Glyphicon, { glyph: 'info-sign' }),
            ' ',
            state.error
          )
        )
      )
    );
  };

  InputField.prototype._renderCheckbox = function _renderCheckbox() {
    var _props4 = this.props,
        id = _props4.id,
        label = _props4.label,
        state = _props4.state,
        normal = _props4.normal,
        inputSize = _props4.inputSize,
        tabIndex = _props4.tabIndex,
        className = _props4.className;

    if (normal) {
      return React.createElement(
        'div',
        { id: id, className: classnames("app-input-field", className) },
        React.createElement(Checkbox, { checkboxClass: 'icheckbox_square-blue', checked: state.value })
      );
    }
    return React.createElement(
      'div',
      { id: id, className: classnames("app-input-field", className) },
      React.createElement(
        FormGroup,
        { validationState: state.hasError ? 'error' : null },
        label && React.createElement(
          Col,
          { componentClass: ControlLabel, md: 12 - inputSize, xs: 3, className: 'text-nowrap' },
          label
        ),
        React.createElement(
          Col,
          { md: inputSize, xs: 9 },
          React.createElement(Checkbox, { checkboxClass: 'icheckbox_square-blue', tabIndex: tabIndex,
            checked: state.value, onChange: function onChange(e, checked) {
              return state.onChange(checked);
            } }),
          state.hasError && React.createElement(
            HelpBlock,
            { className: 'app-margin-left' },
            React.createElement(Glyphicon, { glyph: 'info-sign' }),
            ' ',
            state.error
          )
        )
      )
    );
  };

  InputField.prototype._renderSimple = function _renderSimple() {
    var _props5 = this.props,
        placeholder = _props5.placeholder,
        type = _props5.type,
        state = _props5.state;

    return React.createElement(
      'div',
      { className: 'app-input-field' },
      React.createElement(FormControl, { type: type, placeholder: placeholder,
        value: state.value, onChange: function onChange(e) {
          return state.onChange(e.target.value);
        } })
    );
  };

  InputField.prototype.render = function render() {
    var _props6 = this.props,
        simple = _props6.simple,
        withLabel = _props6.withLabel,
        asLabel = _props6.asLabel,
        type = _props6.type;

    if (type === 'check') return this._renderCheckbox();
    if (simple) return this._renderSimple();
    if (withLabel) return this._renderWithLabel();
    if (asLabel) return this._renderAsLabel();
    return this._renderNormal();
  };

  return InputField;
}(Component), _class2.defaultProps = {
  type: 'text',
  withLabel: false,
  asLabel: false,
  inputSize: 10,
  state: {
    value: '',
    onChange: _.noop
  }
}, _temp)) || _class;

export { InputField as default };
InputField.propTypes = process.env.NODE_ENV !== "production" ? {
  label: PropTypes.string,
  placeholder: PropTypes.string,
  size: PropTypes.string,
  state: PropTypes.object,
  type: PropTypes.string,
  withLabel: PropTypes.bool,
  asLabel: PropTypes.bool,
  mask: PropTypes.string,
  addonLeft: PropTypes.string,
  addonRight: PropTypes.string,
  inputSize: PropTypes.number
} : {};