var _class, _desc, _value, _class2, _descriptor, _descriptor2, _class3, _temp2;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { FormGroup, ControlLabel, FormControl, HelpBlock, Col, Glyphicon } from 'react-bootstrap';
import Select2 from 'react-select2-wrapper';
import classnames from 'classnames';
import $ from 'jquery';
import _ from 'lodash';
import { action, toJS } from 'mobx';
import { observer } from 'mobx-react';

import './SelectField.scss';

var SelectField = observer(_class = (_class2 = (_temp2 = _class3 = function (_Component) {
  _inherits(SelectField, _Component);

  function SelectField() {
    var _temp, _this, _ret;

    _classCallCheck(this, SelectField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _initDefineProp(_this, 'handleChange', _descriptor, _this), _initDefineProp(_this, 'handleNormalChange', _descriptor2, _this), _this.handleCreateTag = function (params) {
      var term = $.trim(params.term);
      if (term === '') return null;
      return {
        id: term,
        text: term,
        newTag: true // add additional parameters
      };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  SelectField.prototype.render = function render() {
    var _props = this.props,
        id = _props.id,
        normal = _props.normal,
        label = _props.label,
        placeholder = _props.placeholder,
        multiple = _props.multiple,
        allowNew = _props.allowNew,
        dropdownParent = _props.dropdownParent,
        options = _props.options,
        inputSize = _props.inputSize,
        state = _props.state,
        children = _props.children,
        tabIndex = _props.tabIndex,
        className = _props.className;


    if (normal) {
      return React.createElement(
        'div',
        { id: id, className: classnames("app-select-field", className) },
        React.createElement(
          FormGroup,
          { validationState: state.hasError ? 'error' : null },
          label && React.createElement(
            Col,
            { componentClass: ControlLabel, md: 12 - inputSize, sm: 2, className: 'text-nowrap' },
            label
          ),
          React.createElement(
            Col,
            { md: inputSize, sm: 10 },
            React.createElement(
              FormControl,
              { componentClass: 'select', value: state.value, tabIndex: tabIndex, onChange: this.handleNormalChange },
              children
            ),
            state.hasError && React.createElement(
              HelpBlock,
              { className: 'app-margin-left' },
              React.createElement(Glyphicon, { glyph: 'info-sign' }),
              ' ',
              state.error
            )
          )
        )
      );
    }

    return React.createElement(
      'div',
      { id: id, className: classnames("app-select-field", className) },
      React.createElement(
        FormGroup,
        { validationState: state.hasError ? 'error' : null },
        label && React.createElement(
          Col,
          { componentClass: ControlLabel, md: 12 - inputSize, sm: 2, className: 'text-nowrap' },
          label
        ),
        React.createElement(
          Col,
          { md: inputSize, sm: 10 },
          React.createElement(Select2, { multiple: multiple, data: toJS(options), tabIndex: tabIndex,
            value: toJS(state.value), onChange: this.handleChange, options: {
              placeholder: placeholder, allowClear: true,
              dropdownParent: dropdownParent,
              tags: allowNew, tokenSeparators: [','], createTag: this.handleCreateTag
            } }),
          state.hasError && React.createElement(
            HelpBlock,
            { className: 'app-margin-left' },
            React.createElement(Glyphicon, { glyph: 'info-sign' }),
            ' ',
            state.error
          )
        )
      )
    );
  };

  return SelectField;
}(Component), _class3.defaultProps = {
  inputSize: 10,
  normal: false,
  allowNew: false,
  onChange: _.noop,
  state: {
    value: undefined,
    onChange: _.noop
  }
}, _temp2), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'handleChange', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this2 = this;

    return function (e) {
      var _props2 = _this2.props,
          state = _props2.state,
          multiple = _props2.multiple,
          options = _props2.options,
          onChange = _props2.onChange;

      var isOptionObject = options && _.isObject(options[0]);
      if (multiple === true) {
        if (isOptionObject) {
          state.onChange($(e.target).select2('data'));
        } else {
          state.onChange($(e.target).select2('data').map(function (option) {
            return option.id;
          }));
        }
      } else {
        state.onChange(e.target.value);
      }
      onChange(e);
    };
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'handleNormalChange', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this3 = this;

    return function (e) {
      var _props3 = _this3.props,
          state = _props3.state,
          onChange = _props3.onChange,
          needText = _props3.needText;

      state.onChange(e.target.value);
      if (needText) {
        if (e.target.value) {
          var $opt = $(e.target).find('option[value=' + e.target.value + ']');
          state.text = $opt.text();
        } else {
          state.text = undefined;
        }
      }
      onChange(e);
    };
  }
})), _class2)) || _class;

export { SelectField as default };
SelectField.propTypes = process.env.NODE_ENV !== "production" ? {
  label: PropTypes.string,
  placeholder: PropTypes.string,
  multiple: PropTypes.bool,
  allowNew: PropTypes.bool,
  state: PropTypes.object,
  inputSize: PropTypes.number,
  normal: PropTypes.bool,
  needText: PropTypes.bool,
  onChange: PropTypes.func
} : {};