var _class, _desc, _value, _class2, _descriptor, _class3, _temp2;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
// import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import { FormGroup, ControlLabel, HelpBlock, Col, Glyphicon } from 'react-bootstrap';
import TagsInput from 'react-tagsinput';
// import Sortable from 'sortablejs';
import classnames from 'classnames';
import { action, observable, toJS } from 'mobx';
import { observer } from 'mobx-react';
// import $ from 'jquery';
import _ from 'lodash';

import 'react-tagsinput/react-tagsinput.css';
import './TagField.scss';

var TagField = observer(_class = (_class2 = (_temp2 = _class3 = function (_Component) {
  _inherits(TagField, _Component);

  function TagField() {
    var _temp, _this, _ret;

    _classCallCheck(this, TagField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.handleSorted = function (e) {
      var state = _this.props.state;

      var tags = toJS(state.value);
      tags.splice(0, 0, tags.splice(1, 1)[0]);
      _this.handleChange(tags);
    }, _initDefineProp(_this, 'handleChange', _descriptor, _this), _this.pasteSplit = function (data) {
      var separators = [',']; // , ';', '\\(', '\\)', '\\*', '/', ':', '\\?', '\n', '\r'];
      return data.split(new RegExp(separators.join('|'))).map(function (d) {
        return d.trim();
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  TagField.prototype.componentDidMount = function componentDidMount() {
    // Sortable.create($(ReactDOM.findDOMNode(this.input)).find(">span")[0], {
    //   draggable: '.react-tagsinput-tag',
    //   onEnd: this.handleSorted
    // });
  };

  TagField.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        id = _props.id,
        label = _props.label,
        placeholder = _props.placeholder,
        inputSize = _props.inputSize,
        state = _props.state,
        tabIndex = _props.tabIndex,
        className = _props.className;


    return React.createElement(
      'div',
      { id: id, className: classnames("app-tag-field", className) },
      React.createElement(
        FormGroup,
        { validationState: state.hasError ? 'error' : null },
        label && React.createElement(
          Col,
          { componentClass: ControlLabel, md: 12 - inputSize, sm: 2, className: 'text-nowrap' },
          label
        ),
        React.createElement(
          Col,
          { md: inputSize, sm: 10, onClick: this.handlePicker },
          React.createElement(TagsInput, { value: state.value, onChange: this.handleChange,
            inputProps: { placeholder: placeholder, tabIndex: tabIndex },
            addOnBlur: true, ref: function ref(el) {
              return _this2.input = el;
            },
            addOnPaste: true, pasteSplit: this.pasteSplit }),
          state.hasError && React.createElement(
            HelpBlock,
            { className: 'app-margin-left' },
            React.createElement(Glyphicon, { glyph: 'info-sign' }),
            ' ',
            state.error
          )
        )
      )
    );
  };

  return TagField;
}(Component), _class3.defaultProps = {
  inputSize: 10,
  state: observable({
    value: [],
    onChange: _.noop
  })
}, _temp2), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'handleChange', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this3 = this;

    return function (tags) {
      var _props2 = _this3.props,
          state = _props2.state,
          sort = _props2.sort;

      var value = tags;
      if (sort === 'float') {
        value = tags.sort(function (a, b) {
          return parseFloat(a) - parseFloat(b);
        });
      }
      state.value = value;
      state.onChange(value);
    };
  }
})), _class2)) || _class;

export { TagField as default };
TagField.propTypes = process.env.NODE_ENV !== "production" ? {
  label: PropTypes.string,
  placeholder: PropTypes.string,
  inputSize: PropTypes.number,
  state: PropTypes.object,
  sort: PropTypes.oneOf(['float'])
} : {};
;