var _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp2;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import { Image } from 'react-bootstrap';
import Lightbox from 'react-images';
import classnames from 'classnames';
import Reflux from 'reflux';
import { observable, action } from 'mobx';
import { observer } from 'mobx-react';
import $ from 'jquery';

import './LightBox.scss';

export var lightBoxActions = Reflux.createActions(['refreshPosition']);

var LightBox = observer(_class = (_class2 = (_temp2 = _class3 = function (_Component) {
  _inherits(LightBox, _Component);

  function LightBox() {
    var _temp, _this, _ret;

    _classCallCheck(this, LightBox);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _initDefineProp(_this, 'isOpen', _descriptor, _this), _initDefineProp(_this, 'openLightBox', _descriptor2, _this), _initDefineProp(_this, 'closeLightbox', _descriptor3, _this), _this.handleRemove = function ($img, $icon) {
      var _this$props = _this.props,
          onRemove = _this$props.onRemove,
          filename = _this$props.filename;

      if (!onRemove) return;
      onRemove(filename);
      lightBoxActions.refreshPosition();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  LightBox.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var removeable = this.props.removeable;

    if (!removeable) return;
    var $img = $(ReactDOM.findDOMNode(this.img));
    var $deleteIcon = $('<span class="glyphicon glyphicon-trash"></span>');
    $deleteIcon.click(function () {
      return _this2.handleRemove($img, $deleteIcon);
    });
    $img.after($deleteIcon);
    $deleteIcon.css($img.position());
    lightBoxActions.refreshPosition.listen(function () {
      return $deleteIcon.css($img.position());
    });
  };

  LightBox.prototype.render = function render() {
    var _this3 = this;

    var _props = this.props,
        src = _props.src,
        fullSrc = _props.fullSrc,
        responsive = _props.responsive,
        className = _props.className,
        style = _props.style;

    return React.createElement(
      'div',
      { className: classnames("app-light-box", className) },
      React.createElement(Image, { src: src, responsive: responsive, style: style, onClick: function onClick(e) {
          return _this3.openLightBox(e);
        }, ref: function ref(el) {
          return _this3.img = el;
        } }),
      React.createElement(Lightbox, { images: [{ src: fullSrc }], showImageCount: false, backdropClosesModal: true,
        isOpen: this.isOpen, onClose: this.closeLightbox })
    );
  };

  return LightBox;
}(Component), _class3.defaultProps = {
  removeable: false
}, _temp2), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'isOpen', [observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'openLightBox', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this4 = this;

    return function (e) {
      e.preventDefault();
      _this4.isOpen = true;
    };
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'closeLightbox', [action], {
  enumerable: true,
  initializer: function initializer() {
    var _this5 = this;

    return function () {
      _this5.isOpen = false;
    };
  }
})), _class2)) || _class;

export { LightBox as default };
LightBox.propTypes = process.env.NODE_ENV !== "production" ? {
  src: PropTypes.string.isRequired,
  fullSrc: PropTypes.string.isRequired,
  removeable: PropTypes.bool,
  filename: PropTypes.string
} : {};