var _class, _class2, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Image, Glyphicon } from 'react-bootstrap';
import classnames from 'classnames';
import { observer } from 'mobx-react';

import VideoDialog from '../dialog/VideoDialog';
import './VideoBox.scss';

var VideoBox = observer(_class = (_temp2 = _class2 = function (_Component) {
  _inherits(VideoBox, _Component);

  function VideoBox() {
    var _temp, _this, _ret;

    _classCallCheck(this, VideoBox);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.handleRemove = function () {
      var _this$props = _this.props,
          onRemove = _this$props.onRemove,
          filename = _this$props.filename;

      if (!onRemove) return;
      onRemove(filename);
    }, _this.handlePlay = function () {
      _this.dialog.show();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  VideoBox.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        src = _props.src,
        removeable = _props.removeable,
        responsive = _props.responsive,
        className = _props.className,
        style = _props.style;

    return React.createElement(
      'div',
      { className: classnames("app-video-box", className), style: style },
      React.createElement(Image, { src: '' + require('assets/images/video.png'), responsive: responsive, onClick: this.handlePlay }),
      removeable && React.createElement(Glyphicon, { glyph: 'trash', onClick: this.handleRemove }),
      React.createElement(VideoDialog, { src: src, ref: function ref(el) {
          return _this2.dialog = el;
        } })
    );
  };

  return VideoBox;
}(Component), _class2.defaultProps = {
  removeable: false
}, _temp2)) || _class;

export { VideoBox as default };
VideoBox.propTypes = process.env.NODE_ENV !== "production" ? {
  src: PropTypes.string.isRequired,
  // fullSrc: PropTypes.string.isRequired,
  removeable: PropTypes.bool
  // filename: PropTypes.string
} : {};